<template>
    <div class="container w-80 mx-auto mt-36">
        <Input v-model="email" label="email" :error="emailError"/>
        <Input v-model="password" label="password" :error="passwordError"/>
        <Input v-model="username" label="username" :error="usernameError"/>
        <div class="relative h-3">
            <p v-if="registerError" class="absolute w-full text-center text-sm text-red-700">
                {{ registerError }}. Please, try again.
            </p>
        </div>
        <div class="flex flex-row justify-between pt-10 pb-4">
            <Button button-label="clear" @clicked="onClickClear"/>
            <Button button-label="sign up" @clicked="onClickSignUp"/>
        </div>
        <p class="text-center text-sm text-gray-700">
            Already a user?
            <router-link class="text-blue-400 underline" to="/sign-in">Sign in</router-link>
            now!
        </p>
    </div>
</template>

<script>
import { mapMutations, mapState } from 'vuex';

const baseURL = "http://localhost:3001/";

export default {
    data() {
        return {
            emailError: "",
            passwordError: "",
            usernameError: "",
            registerError: "",
            email: null,
            password: null,
            username: null,
        };
    },
    computed: {
        ...mapState({
            token: state => state.token,
            userId: state => state.userId,
        }),
    },
    methods: {
        ...mapMutations({
            setToken: 'set',
        }),
        async registerUser() {
            try {
                const res = await this.$axios.post(baseURL + "register/", {
                    email: this.email,
                    password: this.password,
                    username: this.username,
                });
                this.setToken(res.data.accessToken);
                this.$router.push({"name": "users-id", params: { id: this.userId }});
            } catch (e) {
                this.registerError = e.response.data;
            }
        },
        clear() {
            this.email = "";
            this.password = "";
            this.username = "";
            this.clearErrors();
        },
        clearErrors() {
            this.emailError = "";
            this.passwordError = "";
            this.usernameError = "";
            this.registerError = "";
        },
        onClickClear() {
            this.clear();
        },
        onClickSignUp() {
            this.clearErrors();
            if (this.isFormValid()) {
                this.registerUser();
            }
        },
        isFormValid() {
            // Email validation.
            const emailRegex = /^\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;

            if (!this.email) {
                this.emailError = "Email required";
            }
            else if (!emailRegex.test(String(this.email).toLowerCase())) {
                this.emailError = "Invalid email";
            }

            // Password validation.
            if (!this.password) {
                this.passwordError = "Password required.";
            }
            else if (this.password.length < 8) {
                this.passwordError = "Password too short.";
            }
            else if (this.password.length > 32) {
                this.passwordError = "Password too long.";
            }

            // Username validation.
            if (!this.username) {
                this.usernameError = "Username required.";
            }
            else if (this.username.match(/^\d/)) {
                this.usernameError = "Can't begin with a number.";
            }

            if (this.emailError.length > 0 ||
                this.passwordError.length > 0 ||
                this.usernameError.length > 0) {
                return false;
            }
            return true;
        },
    },
};
</script>
